//usingfBNeBuŖOԂ̎QƂȒPɂ܂B
using System;
using System.Drawing;
using System.Windows.Forms;
using Wakaba;

namespace Game
{
    class Game
    {
        //̐
        private const int STAR_MAX = 50;
        //̈ړx
        private const int STAR_SPEED = 4;
        //̉]x
        private const int STAR_ROLL_SPEED = 8;

        private struct StarPos
        {
            //XW
            public int X;
            //YW
            public int Y;
            //Xړ
            public int AddX;
            //Yړ
            public int AddY;
        }

        private const int MAPCHIP_SIZE = 32;
        //XN[Xs[h
        private const int SCROLL_SPEED = 4;

        //fpsvp
        private static int mintFps;
        //t[XLbvvp
        private static int mintSkip;

        //IuWFNgϐ錾܂B
        private static Wakaba.GameTimer t;
        private static Helper w;

        [STAThread]
        static void Main(string[] args)
        {
            try
            {
                Random objRnd = new Random();
                int intRnd;
                int intScroll = 0;

                int intRoll = 0;
                StarPos[] Position = new StarPos[STAR_MAX + 1];

                int intBackFps=0;
                int intBackSkip=0;

                //IuWFNgϐCX^X܂B
                w = new Helper();

                //twp[܂B
                w.Initialize();

                //fps\pXvCg쐬
                w.SpriteCreate("fps", 128, 32);
                w.SpritePosition("fps", 0, 0, 0);
                w.SpriteShow("fps");

                w.SpriteCreate("}bv`bv", MyGame1.Properties.Resources.map, Helper.TransparentColor.None);

                w.SpriteCreate("wi1", 640, 480);
                w.SpriteShow("wi1");

                w.SpriteCreate("wi2", 640, 480);
                w.SpriteShow("wi2");

                //}bv`bv쐬
                for (int i = 0; i <= 14; i++)
                {
                    for (int j = 0; j <= 19; j++)
                    {
                        intRnd = objRnd.Next(0, 3);
                        w.SpriteCopy("wi1", (short)(j * MAPCHIP_SIZE), (short)(i * MAPCHIP_SIZE), "}bv`bv", intRnd * MAPCHIP_SIZE, 0, MAPCHIP_SIZE, MAPCHIP_SIZE);
                    }
                }
                w.SpriteCopy("wi2", 0, 0, "wi1", 0, 0, 640, 480);

                //쐬
                w.SpriteCreate("", MyGame1.Properties.Resources.star, Helper.TransparentColor.PictureTopLeft);
                for (int i = 1; i <= STAR_MAX; i++)
                {
                    w.SpriteCreate("" + i, "", 0, 0, 64, 64);
                    w.SpriteHitAdd("" + i, "萯", 0, 0, 64, 64);

                    objRnd = new Random(i);
                    Position[i].X = objRnd.Next(0, 640 - 64);
                    Position[i].Y = objRnd.Next(0, 480 - 64);
                    Position[i].AddX = STAR_SPEED;
                    Position[i].AddY = STAR_SPEED;

                    w.SpritePosition("" + i, i, Position[i].X, Position[i].Y);
                    w.SpriteTransparent("" + i, 128);

                    w.SpriteShow("" + i);
                }

                //fpsv^C}[ݒ
                t = new Wakaba.GameTimer();
                t.Tick += new GameTimer.TickEventHandler(t_Tick);
                t.Interval = 1000;
                t.TimerStart();

                do
                {
                    //XN[ύX𔻒肷
                    if (w.KeyPush(Helper.KeyCodes.CodeZ))
                    {
                        w.ScreenChange(Helper.ScreenMode.Full);
                    }
                    else if (w.KeyPush(Helper.KeyCodes.CodeX))
                    {
                        w.ScreenChange(Helper.ScreenMode.Window);
                    }

                    //ړ
                    for (int j = 1; j <= STAR_MAX; j++)
                    {

                        Helper.SpriteInfo info = w.SpriteInformation("" + j);

                        if (info.X < 0)
                        {
                            Position[j].AddX = STAR_SPEED;
                        }

                        if (640 - 64 < info.X)
                        {
                            Position[j].AddX = -STAR_SPEED;
                        }

                        if (info.Y < 0)
                        {
                            Position[j].AddY = STAR_SPEED;
                        }

                        if (480 - 64 < info.Y)
                        {
                            Position[j].AddY = -STAR_SPEED;
                        }

                        Position[j].X += Position[j].AddX;
                        Position[j].Y += Position[j].AddY;

                        w.SpriteRotation("" + j, intRoll);
                        w.SpritePosition("" + j, j, Position[j].X, Position[j].Y);
                    }

                    if (intRoll > 360)
                    {
                        intRoll = 0;
                    }
                    else
                    {
                        intRoll += STAR_ROLL_SPEED;
                    }

                    //wiXN[
                    w.SpritePosition("wi1", STAR_MAX + 1, intScroll, 0);
                    w.SpritePosition("wi2", STAR_MAX + 1, intScroll - 640, 0);

                    intScroll += SCROLL_SPEED;
                    if (intScroll > 640)
                    {
                        intScroll = 0;
                    }

                    //fps\
                    if (mintFps == intBackFps & mintSkip == intBackSkip)
                    {
                    }
                    else
                    {
                        string msg = "fps" + mintFps + " skip" + mintSkip;

                        w.SpriteFillColor("fps");
                        w.SpriteText("fps", msg, 0, 0, "lr SVbN", 16, FontStyle.Bold, Brushes.Black);

                        intBackFps = mintFps;
                        intBackSkip = mintSkip;
                    }

                    w.ScreenRefresh(true);
                }

                while (!w.WindowClosing & !w.KeyPush(Helper.KeyCodes.CodeEscape));

                w.ScreenChange(Helper.ScreenMode.Window);

            }
            catch (Exception ex)
            {
                //G[bZ[W\܂B
                MessageBox.Show(ex.Message + ex.StackTrace);
            }

            //twp[̃IuWFNgj܂B
            t.Dispose();
            w.Dispose();
        }

        static void t_Tick()
        {
            //fps\
            if (w != null)
            {

                mintFps = w.ScreenFpsCount;
                mintSkip = w.ScreenFpsSkipCount;

                w.ScreenFpsCount = 0;
                w.ScreenFpsSkipCount = 0;
            }
        }
    }
}